//+------------------------------------------------------------------+
//|                                                      #MTF_MA.mq4 |
//|                                         Copyright  2008, LesioS |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, LesioS"
#property link      "lesios@gmail.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Yellow
#property indicator_width1 1

//---- input parameters
extern int     TimeFrame      = 0;
extern int     MAPeriod       = 9;
extern int     MAShift        = 0;
extern int     MAMethod         = 0;
extern int     Price          = 0;

int back;

//---- indicator buffers
double MABuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   int ft=0;
   string short_name;
//---- indicator line
   IndicatorBuffers(1);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,MABuffer);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   string TimeFrameStr, PriceStr, MethodStr;
   if(TimeFrame == Period())
     TimeFrame = 0;
   switch(TimeFrame)
   {
      case 1 : TimeFrameStr="M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 240 : TimeFrameStr="H4"; break;
      case 1440 : TimeFrameStr="Daily"; break;
      case 10080 : TimeFrameStr="Weekly"; break;
      case 43200 : TimeFrameStr="Monthly"; break;
      default : TimeFrameStr="Current TF";
   }
   
   switch(Price)
   {
      case PRICE_CLOSE: PriceStr="Close"; break;
      case PRICE_OPEN: PriceStr="Open"; break;
      case PRICE_HIGH: PriceStr="High"; break; 
      case PRICE_LOW: PriceStr="Low"; break; 
      case PRICE_MEDIAN: PriceStr="Median"; break; 
      case PRICE_TYPICAL: PriceStr="Typical"; break; 
      case PRICE_WEIGHTED: PriceStr="Weighted"; break;
      default: Price = 0; PriceStr="Close"; break;
   }
   
   switch(MAMethod)
   {
      case MODE_SMA: MethodStr="SMA"; break; 
      case MODE_EMA: MethodStr="EMA"; break; 
      case MODE_SMMA: MethodStr="SMMA"; break; 
      case MODE_LWMA: MethodStr="LWMA"; break; 
      default: MAMethod = 0; MethodStr="SMA"; break;
   }

//---- name for DataWindow and indicator subwindow label
   short_name = "MA(" + TimeFrameStr+", "+ MAPeriod + " " + MethodStr +", " + PriceStr + ")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   if(TimeFrame == 0)
    back = 0;
   else
    back = TimeFrame / Period();
    
   int shift = MAPeriod;
   if(back != 0)
      shift += back;
   SetIndexShift(0,0);
   SetIndexDrawBegin(0,shift);
//----
   return(0);
}

 
//+------------------------------------------------------------------+
//| MTF MA                                                           |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i, limit, y = 0, counted_bars=IndicatorCounted();
 
// Plot defined time frame on to current time frame
   ArrayCopySeries(TimeArray, MODE_TIME, Symbol(), TimeFrame); 

   if (counted_bars<0) return(-1); 
    
   if (counted_bars>0) counted_bars--; 
   
   limit = Bars-counted_bars+back;
   for(i = 0, y = 0; i < limit; i++)
   {
    if(Time[i] < TimeArray[y]) y++;
    MABuffer[i]=iMA(Symbol(), TimeFrame, MAPeriod, MAShift, MAMethod, Price, y);         
   }  
  
   return(0);
  }
//+------------------------------------------------------------------+